Subject: Re: [PATCH v1] tcp: fix connection reset due to tw hashdance race.

From: Simon Horman <[email-masked]>
Date: Tue, 6 Jun 2023 10:57:50 +0200

On Mon, Jun 05, 2023 at 11:51:40AM +0800, Duan Muquan wrote:

...

> Brief of the scenario:
> 
> 1. Server runs on CPU 0 and Client runs on CPU 1. Server closes
> connection actively and sends a FIN to client. The lookback's driver
> enqueues the FIN segment to backlog queue of CPU 0 via
> loopback_xmit()->netif_rx(), one of the conditions for non-delay ack
> meets in __tcp_ack_snd_check(), and the ACK is sent immediately.
> 
> 2. On loopback interface, the ACK is received and processed on CPU 0,
> the 'dance' from original sock to tw sock will perfrom, tw sock will

Hi Duan Muquan,

a minor nit from my side: perfrom -> perform

> be inserted to ehash table, then the original sock will be removed.

...